// $ANTLR 2.7.7 (20060906): "src/main/other/sketch/compiler/parser/StreamItParserFE.g" -> "StreamItParserFE.java"$

package sketch.compiler.parser;

import java.io.DataInputStream;
import java.io.File;
import java.io.IOException;
import java.util.Arrays;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Set;
import java.util.Vector;
import java.util.Map;
import java.util.HashMap;

import sketch.compiler.Directive;
import sketch.compiler.ast.core.FEContext;
import sketch.compiler.ast.core.FieldDecl;
import sketch.compiler.ast.core.Function;
import sketch.compiler.ast.core.Parameter;
import sketch.compiler.ast.core.Program;
import sketch.compiler.ast.core.Annotation;
import sketch.compiler.ast.core.NameResolver;
import sketch.util.datastructures.HashmapList;
import sketch.compiler.ast.core.exprs.ExprStar.Kind;

import sketch.compiler.ast.core.Package;


import sketch.compiler.ast.core.exprs.*;
import sketch.compiler.ast.core.exprs.regens.*;
import sketch.compiler.ast.core.stmts.*;
import sketch.compiler.ast.core.typs.*;
import sketch.compiler.ast.cuda.exprs.*;
import sketch.compiler.ast.cuda.stmts.*;
import sketch.compiler.ast.cuda.typs.*;

import sketch.compiler.ast.promela.stmts.StmtFork;
import sketch.compiler.main.cmdline.SketchOptions;

import sketch.compiler.ast.spmd.stmts.StmtSpmdfork;

import static sketch.util.DebugOut.assertFalse;

public interface StreamItParserFETokenTypes {
	int EOF = 1;
	int NULL_TREE_LOOKAHEAD = 3;
	int TK_atomic = 4;
	int TK_fork = 5;
	int TK_insert = 6;
	int TK_into = 7;
	int TK_loop = 8;
	int TK_repeat = 9;
	int TK_minrepeat = 10;
	int TK_new = 11;
	int TK_null = 12;
	int TK_reorder = 13;
	int TK_assume = 14;
	int TK_hassert = 15;
	int TK_boolean = 16;
	int TK_float = 17;
	int TK_bit = 18;
	int TK_int = 19;
	int TK_void = 20;
	int TK_double = 21;
	int TK_fun = 22;
	int TK_char = 23;
	int TK_struct = 24;
	int TK_ref = 25;
	int TK_adt = 26;
	int TK_if = 27;
	int TK_else = 28;
	int TK_while = 29;
	int TK_for = 30;
	int TK_switch = 31;
	int TK_case = 32;
	int TK_repeat_case = 33;
	int TK_default = 34;
	int TK_break = 35;
	int TK_do = 36;
	int TK_continue = 37;
	int TK_return = 38;
	int TK_true = 39;
	int TK_false = 40;
	int TK_parfor = 41;
	int TK_until = 42;
	int TK_by = 43;
	int TK_implements = 44;
	int TK_assert = 45;
	int TK_assert_max = 46;
	int TK_h_assert = 47;
	int TK_generator = 48;
	int TK_harness = 49;
	int TK_model = 50;
	int TK_fixes = 51;
	int TK_global = 52;
	int TK_serial = 53;
	int TK_spmdfork = 54;
	int TK_stencil = 55;
	int TK_include = 56;
	int TK_pragma = 57;
	int TK_package = 58;
	int TK_extends = 59;
	int TK_let = 60;
	int TK_precond = 61;
	int ARROW = 62;
	int LARROW = 63;
	int WS = 64;
	int LINERESET = 65;
	int SL_COMMENT = 66;
	int ML_COMMENT = 67;
	int LPAREN = 68;
	int RPAREN = 69;
	int LCURLY = 70;
	int RCURLY = 71;
	int LSQUARE = 72;
	int RSQUARE = 73;
	int PLUS = 74;
	int PLUS_EQUALS = 75;
	int INCREMENT = 76;
	int MINUS = 77;
	int MINUS_EQUALS = 78;
	int DECREMENT = 79;
	int STAR = 80;
	int STAR_EQUALS = 81;
	int DIV = 82;
	int DIV_EQUALS = 83;
	int MOD = 84;
	int LOGIC_AND = 85;
	int LOGIC_OR = 86;
	int BITWISE_AND = 87;
	int BITWISE_OR = 88;
	int BITWISE_XOR = 89;
	int ASSIGN = 90;
	int DEF_ASSIGN = 91;
	int TRIPLE_EQUAL = 92;
	int EQUAL = 93;
	int NOT_EQUAL = 94;
	int LESS_THAN = 95;
	int LESS_EQUAL = 96;
	int MORE_THAN = 97;
	int MORE_EQUAL = 98;
	int QUESTION = 99;
	int COLON = 100;
	int SEMI = 101;
	int COMMA = 102;
	int DOT = 103;
	int BANG = 104;
	int LSHIFT = 105;
	int RSHIFT = 106;
	int NDVAL = 107;
	int NDVAL2 = 108;
	int NDVAL2SP = 109;
	int SELECT = 110;
	int NDANGELIC = 111;
	int AT = 112;
	int BACKSLASH = 113;
	int LESS_COLON = 114;
	int DOLLAR = 115;
	int DOTASSIGN = 116;
	int DOTPLUS = 117;
	int DOTMINUS = 118;
	int DOTTIMES = 119;
	int DOTDIV = 120;
	int DOTMOD = 121;
	int DOTLT = 122;
	int DOTGT = 123;
	int DOTLTE = 124;
	int DOTGTE = 125;
	int REGEN = 126;
	int CHAR_LITERAL = 127;
	int STRING_LITERAL = 128;
	int ESC = 129;
	int DIGIT = 130;
	int HQUAN = 131;
	int NUMBER = 132;
	int ID = 133;
	int TK_device = 134;
	int TK_library = 135;
	int TK_printfcn = 136;
}
